var MHO_SHARE_BOOKMARKING = {
	services : ["friendfeed", "delicious","twitter","facebook","myspace","gbookmarks","magnolia","tumblr","jaiku","faves"],
	
	get prefs() { return Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.mahalo.share."); }, 
	get mhoPrefs() { return Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.mahalo."); }, 
	get bmPrefs() { return Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.mahalo.bookmarking."); }, 
	
	serviceData : {
		"delicious": {
			"authenticated": false,
			"name": "del.icio.us",
			"usernameLabel": "Username"
		},
		"twitter": {
			"authenticated": false,
			"name": "Twitter",
			"usernameLabel": "Username"
		},
		"facebook": {
			"authenticated": false,
			"name": "Facebook",
			"usernameLabel": "E-mail address"			
		},
		"myspace": {
			"authenticated": false,
			"name": "MySpace",
			"usernameLabel": "E-mail address"
		},
		"gbookmarks": {
			"authenticated": false,
			"name": "Google Bookmarks",
			"usernameLabel": "E-mail address"
		},
		"magnolia": {
			"authenticated": false,
			"name": "Ma.gnolia",
			"usernameLabel": "Username"
		},
		"tumblr": {
			"authenticated": false,
			"name": "Tumblr",
			"usernameLabel": "E-mail address"
		},
		"jaiku": {
			"authenticated": false,
			"name": "Jaiku",
			"usernameLabel": "Username"
		},
		"faves": {
			"authenticated": false,
			"name": "Faves",
			"usernameLabel": "Username"
		},
		"friendfeed" : {
			"authenticated" : false,
			"name" : "FriendFeed",
			"usernameLabel" : "Username",
			"passwordLabel" : "Remote Key"
		}
	},
	
	get passwordManager() {
		if (Components.classes["@mozilla.org/passwordmanager;1"]) {
			var passwordManager = Components.classes["@mozilla.org/passwordmanager;1"].createInstance();
			passwordManager = passwordManager.QueryInterface(Components.interfaces.nsIPasswordManager);
			
			return passwordManager;
		}
		
		return false;
	},
	
	get loginManager() {
		if (Components.classes["@mozilla.org/login-manager;1"]) {
			var loginManager = Components.classes["@mozilla.org/login-manager;1"].getService(Components.interfaces.nsILoginManager);
			
			return loginManager;
		}
		
		return false;
	},
	
	explainRemoteStorage : function () {
		var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
		var string = "No one, including Mahalo, can view your usernames and passwords.\n\nYour login data is encrypted before it is sent to Mahalo. When you login to Mahalo to import your login data, the info is sent to your computer where it is decrypted. Your login data never leaves your computer unencrypted.\n\nYou can enable or disable this feature at any time.";
		
		prompts.alert(window, "Protecting Your Login Data", string);
	},
	
	syncToServer : function () {
		if (document.getElementById("authdeck")) {
			document.getElementById("authdeck").selectedIndex = 4;
			document.getElementById("auth-loading").style.visibility = '';
		}
		
		for (var i in this.serviceData) {
			var serviceUrl = "http://" + i + ".mahalo.com/";
		
			var auth = this.getLogin(serviceUrl, true);
		
			if (auth.username) {
				this.addLogin(serviceUrl, auth.username, auth.password);
			}
		
			this.removeLogin(serviceUrl, true);
		}
		
		if (document.getElementById("authdeck")) {
			document.getElementById("authdeck").selectedIndex = 5;
			document.getElementById("auth-loading").style.visibility = 'hidden';
		}
	},
	
	syncFromServer : function () {
		if (document.getElementById("authdeck")) {
			document.getElementById("authdeck").selectedIndex = 4;
			document.getElementById("auth-loading").style.visibility = '';
		}
		
		// Get the user's locally stored Mahalo password.
		var mahaloLogin = this.getMahaloLogin();
		
		// MD5 hash it.
		var hash = mhos_hash(mahaloLogin.password, "MD5", true);
		
		// Request the encrypted password from the API
		var req = new XMLHttpRequest();
		
		var args = { };
		args.hash = hash;
		args.un = mahaloLogin.username;
		
		var postData = MHO_SHARE_API.createPostRequest(args);
		
		req.open("POST", this.prefs.getCharPref("uris.api.accountStore") + "?action=accountstore&format=json", true);
		req.setRequestHeader("Content-Type","multipart/form-data; boundary=" + postData.boundary);
		req.setRequestHeader("Content-Length", (postData.requestBody.available()));
		
		req.onreadystatechange = function () {
			if (req.readyState == 4) {
				var json = eval("(" + req.responseText + ")");
		
				if (json.accounts.result == 'NotExists') {
					try {
						MHO_SHARE_BOOKMARKING.removeLogin("http://mahalo.mahalo.com/", true);
					} catch (didntExistAnyway) { }
			
					MHO_SHARE_BOOKMARKING.getMahaloLogin();
					return MHO_SHARE_BOOKMARKING.syncFromServer();
				}
				
				var auth = {};

				for (var i in json.accounts) {
					if (json.accounts[i].service) {
						var service = json.accounts[i].service;
						var serviceUrl = 'http://' + service + '.mahalo.com/';
						
						try {
							var username = json.accounts[i].username;
							var password = json.accounts[i].password;

							// Decrypt it.
							username = MHO_SHARE_CRYPT.decrypt(username, mahaloLogin.password);
							password = MHO_SHARE_CRYPT.decrypt(password, mahaloLogin.password);
							
							MHO_SHARE_BOOKMARKING.removeLogin(serviceUrl, true);
							MHO_SHARE_BOOKMARKING.addLogin(serviceUrl, username, password, true);
						} catch (passwordNotOnServer) {
							logMhoShareMsg("Error syncing from server: " + passwordNotOnServer);
						}
					}
				}
				
				if (document.getElementById("authdeck")) {
					document.getElementById("authdeck").selectedIndex = 5;
					document.getElementById("auth-loading").style.visibility = 'hidden';
				}
			}
		};
		
		req.send(postData.requestBody);
	},
	
	getAllRemoteLogins : function () {
		// Get the user's locally stored Mahalo password.
		
		var mahaloLogin = this.getMahaloLogin();
		
		// MD5 hash it.
		var hash = mhos_hash(mahaloLogin.password, "MD5", true);
		
		// Request the encrypted password from the API
		var req = new XMLHttpRequest();
		
		var args = { };
		args.hash = hash;
		args.un = mahaloLogin.username;
		
		var postData = MHO_SHARE_API.createPostRequest(args);
		
		req.open("POST", this.prefs.getCharPref("uris.api.accountStore") + "?action=accountstore&format=json", false);
		
		req.setRequestHeader("Content-Type","multipart/form-data; boundary=" + postData.boundary);
		req.setRequestHeader("Content-Length", (postData.requestBody.available()));
		
		req.send(postData.requestBody);

		var json = eval("(" + req.responseText + ")");
		
		if (json.accounts.result == 'NotExists') {
			try {
				this.removeLogin("http://mahalo.mahalo.com/", true);
			} catch (didntExistAnyway) { }
			
			this.getMahaloLogin();
			return this.getAllRemoteLogins();
		}
		
		var auth = {};
		
		for (var i in json.accounts) {
			if (json.accounts[i].service) {
				var service = json.accounts[i].service;
				
				auth[service] = {};
				
				try {
					auth[service].username = json.accounts[i].username;
					auth[service].password = json.accounts[i].password;

					// Decrypt it.
					auth[service].username = MHO_SHARE_CRYPT.decrypt(auth[service].username, mahaloLogin.password);
					auth[service].password = MHO_SHARE_CRYPT.decrypt(auth[service].password, mahaloLogin.password);
				} catch (passwordNotOnServer) {
					logMhoShareMsg("Error retrieving logins: " + passwordNotOnServer);
				}
			}
		}
		
		// Return it.
		return auth;
	},
	
	getMahaloLogin : function () {
		var mahaloLogin = this.getLogin("http://mahalo.mahalo.com/", true);
		
		if (!mahaloLogin.username || !mahaloLogin.password) {
			var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
			
			var usernamePref = this.mhoPrefs.getCharPref("username");
			
			if (!usernamePref) {
				var ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
				var uri = ios.newURI(this.prefs.getCharPref("uris.referralCookieDomain"), null, null);
				var cookieSvc = Components.classes["@mozilla.org/cookieService;1"].getService(Components.interfaces.nsICookieService);
				var cookieString = cookieSvc.getCookieString(uri, null);

				if (cookieString) {
					var cookies = cookieString.split(";");

					for (var i = 0; i < cookies.length; i++){
						if (cookies[i].match(/wikidbUserName/gi)) {
							usernamePref = cookies[i].split("=")[1];
							break;
						}
					}
				}
				
				if (!usernamePref) {
					usernamePref = '';
				}
			}
			
			if (usernamePref) {
				this.mhoPrefs.setCharPref("username", usernamePref);
			}
			
			username = { value: usernamePref };
			password = { value: "" };

			okorcancel = prompts.promptUsernameAndPassword(window, 'Link my login data with my Mahalo account', 'Enter your Mahalo username and password so you can import your login data, for all the different services, when you use Follow on another computer.', username, password, null, { value : ""});
			
			if (okorcancel) {
				this.addLogin("http://mahalo.mahalo.com/", username.value, password.value, true);
				mahaloLogin.username = username.value;
				mahaloLogin.password = password.value;
				this.mhoPrefs.setCharPref("username", username.value);
			}
			else {
				if (this.bmPrefs.getBoolPref("remoteLogins")) {
					this.bmPrefs.setBoolPref("remoteLogins", false);
					alert("You've disabled linking your login data with your Mahalo account.");
					return false;
				}
			}
		}
		
		return mahaloLogin;
	},
	
	getLogin : function (loginUrl, forceLocal) {
		if (!forceLocal && this.bmPrefs.getBoolPref("remoteLogins")) {
			// Get the user's locally stored Mahalo password.
			var auth = { 'username' : "", 'password' : "" };
			
			var mahaloLogin = this.getMahaloLogin();
			
			if (mahaloLogin) {
				// MD5 hash it.
				var hash = mhos_hash(mahaloLogin.password, "MD5", true);
			
				// Request the encrypted password from the API
				var req = new XMLHttpRequest();
			
				var args = { };
				args.hash = hash;
				args.un = mahaloLogin.username;
				args.service = loginUrl.match(/http:\/\/([^\.]+).mahalo.com\//i)[1];
			
				var postData = MHO_SHARE_API.createPostRequest(args);
			
				req.open("POST", this.prefs.getCharPref("uris.api.accountStore") + "?action=accountstore&format=json", false);
			
				req.setRequestHeader("Content-Type","multipart/form-data; boundary=" + postData.boundary);
				req.setRequestHeader("Content-Length", (postData.requestBody.available()));
			
				req.send(postData.requestBody);

				var json = eval("(" + req.responseText + ")");
			
				if (json.accounts.result == 'NotExists') {
					try {
						this.removeLogin("http://mahalo.mahalo.com/", true);
					} catch (didntExistAnyway) { }
				
					if (this.getMahaloLogin()) {
						return this.getLogin(loginUrl);
					}
					else {
						return;
					}
				}
			
				try {
					auth.username = json.accounts["0"].username;
					auth.password = json.accounts["0"].password;

					// Decrypt it.
					auth.username = MHO_SHARE_CRYPT.decrypt(auth.username, mahaloLogin.password);
					auth.password = MHO_SHARE_CRYPT.decrypt(auth.password, mahaloLogin.password);
				} catch (passwordNotOnServer) {
					logMhoShareMsg("Error retrieving login: " + passwordNotOnServer);
				}
			}
		
			// Return it.
			return auth;
		}
		else {
			var auth = {};

			var passwordManager = this.passwordManager;
			var loginManager = this.loginManager;

			if (passwordManager) {
				var e = passwordManager.enumerator;

				// step through each password in the password manager until we find the one we want:
				while (e.hasMoreElements()) {
				    try {
				        // get an nsIPassword object out of the password manager.
				        // This contains the actual password...
				        var pass = e.getNext().QueryInterface(Components.interfaces.nsIPassword);
				        if (pass.host == loginUrl) {
							auth.username = pass.user;
							auth.password = pass.password;
							break;
				        }
				    } catch (ex) {
				    }
				}
			}
			else {
				var nsLoginInfo = new Components.Constructor("@mozilla.org/login-manager/loginInfo;1", Components.interfaces.nsILoginInfo, "init");
				var logins = loginManager.findLogins({}, loginUrl, "chrome://mahalo-" + "follow", null);
				for (var j = 0; j < logins.length; j++) {
					auth.username = logins[j].username;
					auth.password = logins[j].password;
					break;
				}
			}
		
			if (typeof auth.username == 'undefined') auth.username = '';
			if (typeof auth.password == 'undefined') auth.password = '';
			
			return auth;
		}
	},
	
	removeLogin : function (loginUrl, forceLocal) {
		if (!forceLocal && this.bmPrefs.getBoolPref("remoteLogins")) {
			var mahaloLogin = this.getMahaloLogin();
			var service = loginUrl.match(/http:\/\/([^\.]+).mahalo.com\//i)[1];
			var un = mahaloLogin.un;
			var hash = mhos_hash(mahaloLogin.password, "MD5", true);
			
			var args = { };
			args.method = 'delete';
			args.un = mahaloLogin.username;
			args.service = service;
			args.hash = hash;
			
			var req = new XMLHttpRequest();
			
			var postData = MHO_SHARE_API.createPostRequest(args);
			
			req.open("POST", this.prefs.getCharPref("uris.api.accountStore") + "?action=accountstore&format=json", true);
			req.setRequestHeader("Content-Type","multipart/form-data; boundary=" + postData.boundary);
			req.setRequestHeader("Content-Length", (postData.requestBody.available()));
			
			req.onreadystatechange = function () {
				if (req.readyState == 4) {
				}
			};
			
			req.send(postData.requestBody);
		}
		else {
			var passwordManager = this.passwordManager;
			var loginManager = this.loginManager;
		
			if (passwordManager) {
				var e = passwordManager.enumerator;
				var usernames = [];
			
				while (e.hasMoreElements()) {
				    try {
				        var pass = e.getNext().QueryInterface(Components.interfaces.nsIPassword);
			
				        if (pass.host == loginUrl) {
							usernames.push(pass.user);
				        }
				    } catch (ex) {
				    }
				}
			
				for (var i = 0; i < usernames.length; i++){
					try{
						passwordManager.removeUser(loginUrl, usernames[i]);
					} catch (e) {
					}
				}
			}
			else {
				// Remove any password we have stored for this in the past.
				var logins = loginManager.findLogins({}, loginUrl, "chrome://mahalo-" + "follow", null);

				for (var j = 0; j < logins.length; j++) {
					loginManager.removeLogin(logins[j]);
				}
			}
		}
	},
	
	addLogin : function (loginUrl, username, password, forceLocal) {
		try {
			if (typeof MHO_SHARE_BMS_WIZARD != 'undefined' || typeof MHO_SHARE_PREFS != 'undefined') {
				var service = loginUrl.match(/http:\/\/([^\.]+).mahalo.com\//i)[1];
				document.getElementById("username-" + service).value = username;
				document.getElementById("password-" + service).value = password;
				document.getElementById("checkbox-" + service).checked = true;
			}
		} catch (e) {
		}
		
		if (!forceLocal && this.bmPrefs.getBoolPref("remoteLogins")) {
			try {
				var mahaloLogin = this.getMahaloLogin();
				var cryptUsername = MHO_SHARE_CRYPT.encrypt(username, mahaloLogin.password);
				var cryptPassword = MHO_SHARE_CRYPT.encrypt(password, mahaloLogin.password);
				var service = loginUrl.match(/http:\/\/([^\.]+).mahalo.com\//i)[1];
				var hash = mhos_hash(mahaloLogin.password, "MD5", true);
			
				var args = { };
				args.method = 'save';
				args.un = mahaloLogin.username;
				args.service = service;
				args.username = cryptUsername;
				args.password = cryptPassword;
				args.hash = hash;
			
				var req = new XMLHttpRequest();
			
				var postData = MHO_SHARE_API.createPostRequest(args);
			
				req.open("POST", this.prefs.getCharPref("uris.api.accountStore") + "?action=accountstore&format=json", true);
				req.setRequestHeader("Content-Type","multipart/form-data; boundary=" + postData.boundary);
				req.setRequestHeader("Content-Length", (postData.requestBody.available()));
			
				req.onreadystatechange = function () {
					if (req.readyState == 4) {
						try {
							var json = eval("(" + req.responseText + ")");
							
							if (json.accounts.result == 'NotExists') {
								try {
									this.removeLogin("http://mahalo.mahalo.com/", true);
								} catch (didntExistAnyway) { }

								MHO_SHARE_BOOKMARKING.getMahaloLogin();
								MHO_SHARE_BOOKMARKING.addLogin(loginUrl, username, password);
							}
							else if (json.accounts.result == 'ReadOnly') {
								alert("Mahalo is currently undergoing some maintenance.  You'll be able to add an account again in a few minutes.");
							}
						} catch (invalidJSON) {
							alert("The Mahalo server could not be reached.");
						}
					}
				};
			
				req.send(postData.requestBody);
			} catch (e) {
				logMhoShareMsg("Error adding login: " + e);
			}
		}
		else {
			var passwordManager = this.passwordManager;
			var loginManager = this.loginManager;
		
			if (passwordManager) {
				passwordManager.addUser(loginUrl, username, password);
			}
			else {
				var nsLoginInfo = new Components.Constructor("@mozilla.org/login-manager/loginInfo;1", Components.interfaces.nsILoginInfo, "init");
				var loginInfo = new nsLoginInfo(loginUrl, 'chrome://mahalo-' + 'follow', null, username, password, "", "");
				loginManager.addLogin(loginInfo);
			}
		}
	}
};