var MHO_SHARE = {
	get browser() { 
		try {
			var sidebar = document.getElementById("sidebar-box");
			
			if (!sidebar.getAttribute("hidden") && sidebar.getAttribute("sidebarcommand") == 'mahalo-share-do_follow'){
				return document.getElementById("sidebar").contentDocument.getElementById("mahalo-share-browser");
			}
			
			return null;
		} catch (e) {
			logMhoShareMsg("ERROR IN get browser: " + e);
		}
	},
	
	get referrerId() { try { return MHO_SHARE.prefs.getCharPref("refID"); } catch (e) { return ''; } },
	get extensionId() { try { return MHO_SHARE.prefs.getCharPref("extID"); } catch (e) { return ''; } },
	get followService() { return MHO_SHARE.prefs.getCharPref("uris.followService"); },
	
	regex : {},

	lastPageSent : null,
	
	currentPage : null,
	
	lastUrlLoaded : null,
	sidebarUrl : null,
	
	tags : [
		{tag : "h1", score : 14, limit : 10},
		{tag : "h2", score : 11, limit : 10},
		{tag : "h3", score : 9, limit : 10},
		{tag : "h4", score : 7, limit : 10},
		{tag : "a", score : 4, limit : 25},
		{tag : "b", score : 2, limit : 10},
		{tag : "em", score : 2, limit : 5},
		{tag : "p", score : 2, limit : 5},
		{tag : "span", score : 1, limit : 5},
		{tag : "div", score : 1, limit : 5}
		],
		
	openPrefs : function () {
		openDialog('chrome://mahalo-share/content/options.xul','','chrome,titlebar,toolbar,centerscreen');
	},
	
	init : function () {
		MHOS_VERSION = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager).getItemForID("share@mahalo.com").version;
		
		var prefBranch = "extensions.mahalo.share.";
		this.prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch(prefBranch);

		// Give this profile a random ID to identify only for install/uninstall stats
		if (!this.prefs.prefHasUserValue("extID")){
			var randomID = Math.round(Math.random() * 1000000000);
			this.prefs.setCharPref("extID",randomID);
			if (MHOS_DEBUG) logMhoShareMsg("Setting extension ID to " + randomID);
		}
		
		if (!this.prefs.prefHasUserValue("version") || this.prefs.getCharPref("version") != MHOS_VERSION){
			if (MHOS_DEBUG) logMhoShareError("Version number has changed.");
			
			if (!this.isMahaloShare()) {
				// Show the "Thank You for installing" page
				setTimeout('gBrowser.selectedTab = gBrowser.addTab("' + this.prefs.getCharPref("uris.thankYou") + '");', 1000);
			}
			
			if (!this.prefs.prefHasUserValue("version")){
				if (this.isMahaloShare()) {
					// Hide the Share toolbar if it's showing.
					var shareToolbar = document.getElementById("mahalo-share-toolbar");
					
					if (shareToolbar) {
						shareToolbar.setAttribute("collapsed","true");
					}
				}
				
				setTimeout('MHO_SHARE.installMahaloSearch();', 5000);
				
				if (MHOS_DEBUG) logMhoShareMsg("Setting timer for Mahalo engine install.");
			}
		
			// For now, make sure that the Follow button is on the toolbar
			
			if (!this.isMahaloShare()) {
				var buttonId = "mahalo-share-button";
				var equivalentButtonId = "mahalo-share-button";
			}
			else {
				var buttonId = "mahalo-share-share-button";
				var equivalentButtonId = "mahalo-share-share-button";
			}
			
			if (!document.getElementById(buttonId) && !document.getElementById(equivalentButtonId)){
				if (MHOS_DEBUG) logMhoShareMsg("Adding Mahalo button to the toolbar.");
				
				// Determine which toolbar to place the icon onto
				if (document.getElementById("nav-bar").getAttribute("collapsed") != "true"){
					var toolbar = document.getElementById("nav-bar");
				}
				else {
					var toolbar = document.getElementById("toolbar-menubar");
				}

				var currentSet = toolbar.currentSet;
				var newSet = currentSet;
				var setItems = currentSet.split(',');
	
				var toolbox = document.getElementById("navigator-toolbox") || document.getElementById("browser-toolbox");
				var toolboxDocument = toolbox.ownerDocument;
	
				function mahaloGetIndex(array, val){
					for (var i = 0; i < array.length; i++){
						if (array[i] == val) {
							return i;
						}
					}
		
					return -1;
				}
	
				// Order of adding:
					// before urlbar-container
					// after home-button
					// after reload-button
					// after stop-button
					// after forward-button
					// before search-container
					// at the end
	
				if (mahaloGetIndex(setItems, "urlbar-container") != -1){
					newSet = currentSet.replace("urlbar-container",buttonId+",urlbar-container");
				}
				else if (mahaloGetIndex(setItems, "home-button") != -1){
					newSet = currentSet.replace("home-button","home-button,"+buttonId);
				}
				else if (mahaloGetIndex(setItems, "reload-button") != -1){
					newSet = currentSet.replace("reload-button","reload-button,"+buttonId);
				}
				else if (mahaloGetIndex(setItems, "stop-button") != -1){
					newSet = currentSet.replace("stop-button","stop-button,"+buttonId);
				}
				else if (mahaloGetIndex(setItems, "forward-button") != -1){
					newSet = currentSet.replace("forward-button","forward-button,"+buttonId);
				}
				else if (mahaloGetIndex(setItems, "search-container") != -1){
					newSet = currentSet.replace("search-container",buttonId+",search-container");
				}
				else {
					newSet = toolbar.currentSet + ","+buttonId;
				}
	
				toolbar.currentSet = newSet;
				toolbar.setAttribute("currentset",newSet);
	
				toolboxDocument.persist(toolbar.id, "currentset");
	
				try {
					BrowserToolboxCustomizeDone(true);
				} catch (e) { }
			}
			
			this.prefs.setCharPref("version", MHOS_VERSION);
			
			if (!this.prefs.prefHasUserValue("refID")){
				if (MHOS_DEBUG) logMhoShareMsg("No refID; checking for cookie.");
				
				var ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
				var uri = ios.newURI(MHO_SHARE.prefs.getCharPref("uris.referralCookieDomain"), null, null);
				var cookieSvc = Components.classes["@mozilla.org/cookieService;1"].getService(Components.interfaces.nsICookieService);
				var cookieString = cookieSvc.getCookieString(uri, null);
				var foundIt = false;
				
				if (cookieString) {
					logMhoShareError("Mahalo Cookie found, setting referrer.");
					
					var cookies = cookieString.split(";");
			
					for (var i = 0; i < cookies.length; i++){
						if (cookies[i].match(/follow_refID/gi)) {
							var refID = cookies[i].split("=")[1];
							this.prefs.setCharPref("refID",refID);
							if (MHOS_DEBUG) logMhoShareMsg("Found cookie, setting refID to " + refID);
							logMhoShareError("Setting referrer ID to " + refID);
							foundIt = true;
							break;
						}
					}
					
					if (!foundIt) {
						logMhoShareError("Mahalo cookies exist, but not follow_refID.");
					}
				}
				else {
					logMhoShareError("No Mahalo cookies found; can't set referrer Id.");
				}
			}
			
			MHO_SHARE_API.send_install();
		}
		
		// Words starting with numbers, 1 and 2 letter words, days, months, the 100 most common words
		this.regex.invalidWords = /\s+(.{1,2}|[0-9]+(am|pm|st|nd|rd|th)|[^\s]*\.com|posts?|comments?|[^a-z]+|http.*|(www.*)|[\S]*title[\S]*|too|site|var|ago|hours|reply|most|view|replies|january|february|march|april|may|june|july|august|september|october|november|december|jan|feb|mar|apr|may|june|july|aug|sep|oct|nov|dec|mon|tue|wed|thu|fri|sat|days?|sun|monday|tuesday|wednesday|thursday|friday|saturday|sunday|the|cant|dont|and|you|that|was|for|are|with|his|they|this|have|from|one|had|word|but|not|what|all|were|when|your|can|said|there|use|each|which|she|how|their|will|other|about|out|many|then|them|these|some|her|would|make|like|him|into|time|has|look|two|more|write|see|number|way|could|people|than|first|water|been|call|who|oil|its|now|find|long|down|day|did|get|come|made|may|part)\s+/gm;

		// Get rid of any special characters just for simplicity
		this.regex.invalidCharacters = new RegExp("[^a-z0-9\\s]","g");

		// Strip HTML
		this.regex.html = new RegExp("(<([^>]+)>)", "g");
		
		// Strip e-mail addresses
		this.regex.email = /[a-z0-9._%+-]+@[a-z0-9.-]+\.[a-z]{2,6}/g;
		this.regex.domains = /[^s]*\.(com|net|org)/g;
		
		// Get rid of entities
		this.regex.entities = new RegExp("&.{2,5};|\/", "g");

		// Clear consecutive spaces
		this.regex.multiSpaces = new RegExp("\\s{2,}", "g");
	},

	installMahaloSearch : function () {
		if (MHOS_DEBUG) logMhoShareMsg("Installing Mahalo search engine.");
		
		if (window.external && ("AddSearchProvider" in window.external)){
			function cloneEngine(aEngine) {
				var newO=[];
				for (var i in aEngine)
					newO[i] = aEngine[i];
				newO.originalEngine = aEngine;
				return newO;
			}
	
			var searchService = Components.classes["@mozilla.org/browser/search-service;1"];
	
			if (searchService) {
				searchService = searchService.getService(Components.interfaces.nsIBrowserSearchService);
				var engines = searchService.getVisibleEngines({}).map(cloneEngine);
		
				for (var i in engines){
					if (engines[i].name == "Mahalo (English)"){
						if (MHOS_DEBUG) logMhoShareMsg("Mahalo search is already installed.");
						return false;
					}
				}
		
				window.external.AddSearchProvider(MHO_SHARE.prefs.getCharPref("uris.openSearch"));
		
				return true;
			}
			else {
				return false;
			}
		}
		else {
			return false;
		}
	},

	openMahaloSidebar : function () {
		toggleSidebar('mahalo-share-do_follow');
	},

	autoSearch : function (keywords) {
		// Called from the URL listener. We have an apparent search going on.
		var req = new XMLHttpRequest();
		req.open("GET", MHO_SHARE.followService + "?action=checkForMatch&string=" + encodeURIComponent(keywords), true);
		
		req.onreadystatechange = function (event) {
			if (req.readyState == 4){
				try {
					if (req.status == 200){
						if (MHOS_DEBUG) logMhoShareMsg("Received direct-match check response: " + req.responseText);
						
						if (req.responseText != '0') {
							MHO_SHARE.openMahaloSidebar();
						}
					}
				} catch (e) { }
			}
		};
		
		if (MHOS_DEBUG) logMhoShareMsg("Checking for Mahalo match on search for " + keywords);
		
		req.send(null);
	},

	onContentLoad : function (event, force) {
		var page = event.target;
		var url = page.location.href;
		
		// Times when we want to just empty the sidebar
		if (!url.match(/^http/i)){
			// Non-http URLs
			if (url == content.document.location.href) {
				if (MHOS_DEBUG) logMhoShareMsg("Page is not http, not showing any results");	
			
				this.showResults(null, "");
			}
			
			this.lastUrlLoaded = null;
			
			return;
		}
		
		if (force && url == content.document.location.href && gBrowser.selectedTab.busy) {
			// Pages that haven't finished loading
			this.showResults(null, "");
			return;
		}
		
		if (url == this.lastUrlLoaded) {
			return;
		}
		
		if (!force) {
			// Make sure that this is a top-level document.
			var doc = event.originalTarget;
		
			if (event.originalTarget.defaultView.frameElement) {
				if (doc.defaultView.frameElement.ownerDocument != doc) {
					return;
				}
			}
		}

		if (MHOS_DEBUG) logMhoShareMsg("Content load: " + url);
		
		if (!this.customKeywords(page)){
			if (content.document.MHOS_KEYWORDS) {
				// Has been processed before.
				this.showResults(url, content.document.MHOS_KEYWORDS);
				
				if (MHOS_DEBUG) logMhoShareMsg("Using cached keywords for " + url);
			}
			else {
				var keywords = [];

				function addKeyword(word, score){
					for (var i = 0; i < keywords.length; i++){
						if (keywords[i].word == word){
							keywords[i].score += score;					
							return;
						}
					}
	
					keywords.push({"word" : word, "score" : score});
	
					return;
				}
		
				var doc = page.documentElement;

				if (doc) {
					doc = doc.cloneNode(true);
			
					var uselessTags = doc.getElementsByTagName("script");
					var start = uselessTags.length - 1;
					for (var i = start; i >= 0; i--){
						uselessTags[i].parentNode.removeChild(uselessTags[i]);
					}
			
				 	uselessTags = doc.getElementsByTagName("style");
					var start = uselessTags.length - 1;
					for (var i = start; i >= 0; i--){
						uselessTags[i].parentNode.removeChild(uselessTags[i]);
					}
			
					uselessTags = doc.getElementsByTagName("img");
					var start = uselessTags.length - 1;
					for (var i = start; i >= 0; i--){
						uselessTags[i].parentNode.removeChild(uselessTags[i]);
					}
			
					var numTags = this.tags.length;
			
					for (var h = 0; h < numTags; h++){
						var tag = this.tags[h];
				
						var tagResults = doc.getElementsByTagName(tag.tag);
						var tagLimit = Math.min(tagResults.length, tag.limit);
				
						for (var i = 0; i < tagLimit; i++){
							if (tagResults[0]){
								var words = tagResults[0].innerHTML;
								words = words.toLowerCase();
								words = words.replace(/\s/, " ");
								words = words.replace(this.regex.html," ");
								words = words.replace(this.regex.entities, " ");
								words = words.replace(this.regex.email, " ");
								words = words.replace(this.regex.domains, " ");
								words = words.replace(this.regex.invalidCharacters,"");
								words = words.replace(this.regex.multiSpaces," ");
								words = " "+words+" ";
			
								while (words != (words = words.replace(this.regex.invalidWords," "))){ }
					
								words = words.replace(this.regex.multiSpaces," ");
								words = words.replace(/^\s+|\s+$/, "");
						
								if (words) {
									words = words.split(" ");
									for (var j = 0; j < words.length; j++){
										var re = new RegExp(words[j], "gi");
							
										if (!page.location.host.match(re)){
											addKeyword(words[j], tag.score);
										}
									}
								}
			
								tagResults[0].parentNode.removeChild(tagResults[0]);
							}
						}
					}
				}
		
				function sortByScore(a, b){
					if (a.score == b.score) {
						// This should ensure that words higher up in the page appear earlier in the keyword array
						return -1;
					}
					else {
						return b.score - a.score;
					}
				}
		
				keywords = keywords.sort(sortByScore);
				keywords = keywords.slice(0, 40);
		
				if (MHOS_DEBUG)  {	
					var s = '';
					for (var q = 0; q < keywords.length; q++) {
						s += keywords[q].word + ": " + keywords[q].score + ", ";
					}
		
					logMhoShareMsg(s);
				}
		
				var len = keywords.length;
		
				for (var i = 0; i < len; i++){
					keywords[i] = keywords[i].word;
				}
		
				keywords = keywords.join(":");
				page.MHOS_KEYWORDS = keywords;
				
				if (MHOS_DEBUG) logMhoShareMsg("About to send keywords");
				
				if (!force || !gBrowser.selectedTab.busy) {
					this.showResults(url, keywords);
					this.lastUrlLoaded = url;
				}
			}
		}
	},
	
	customKeywords : function (page) {
		var url = page.location.href; 
		if (MHOS_DEBUG) logMhoShareMsg("Looking for custom keywords for " + url);
		
		if (page.MHOS_KEYWORDS) {
			if (MHOS_DEBUG) logMhoShareMsg("Using cached keywords for " + url);
			
			this.showResults(url, page.MHOS_KEYWORDS);
			return true;
		}
		else if (page.MHO_SERP) {
			if (MHOS_DEBUG) logMhoShareMsg("Using cached serp keywords for " + url);
			
			this.showRelated(url, page.MHO_SERP);
			return true;
		}
		
		var host = page.location.host;		
		
		try {
			if (matches = url.match(/[\?&](q|p|w|wd|query|search|search_query|satitle)=([^&]+)/i)){
				var keywords = decodeURIComponent(matches[2]).split("+");
				if (MHOS_DEBUG) logMhoShareMsg("Found custom keywords in the URL.");
			}
			else if (host.match(/\.flickr\./)){
				//  Look for tags
				var links = page.evaluate("//a[@href]", page, null, XPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
				var alink = links.iterateNext();
				var keywords = [];
				var tag = null;
			
				while (alink){
					if (tag = alink.getAttribute("href").match(/photos\/tags\/([^\/]+)\//i)){
						tag = tag[1].toLowerCase();
					
						if (!mhos_inArray(keywords, tag)){
							keywords.push(tag);
						}
					}
				
					alink = links.iterateNext();
				}
			}
			else if (host.match(/\.wikipedia\./)){
				var keywords = [];
			
				if (url.match(/wiki\/[^:\.]+[^\.]$/i)){
					var h1s = page.getElementsByTagName("h1");
	
					for (var i = 0; i < h1s.length; i++){
						if (h1s[i].className == "firstHeading") {
							keywords = [ h1s[i].firstChild.nodeValue ];
							break;
						}
					}
				}
	
				if (keywords.length == 0){
					keywords = page.getElementsByName("keywords")[0].getAttribute("content");
					if (!keywords.match(/^Special:Search/)) {
						keywords = keywords.split(",");
					}
					else {
						keywords = [];
					}
				}
			}
			else if (host.match(/(mahalo)/)){
				if (url.match(/\.com\/[^:\?]+$/i) && !url.match(/\.php/)){
					try {
						var serp = page.getElementsByName("keywords")[0].getAttribute("content").split(",")[0];
						page.MHO_SERP = serp;
						this.showRelated(url, serp);
					
						return true;
					} catch (ex) {
					}
				}
				else {
					this.showRelated(url);
				}
			}

			if (MHOS_DEBUG) logMhoShareMsg("Custom keywords ("+keywords.length+"): " + keywords);

			if (keywords && keywords.length > 0 && keywords[0] != '') {
				keywords = keywords.join(":");
				page.MHOS_KEYWORDS = keywords;
				this.showResults(url, keywords);
	
				return true;
			}
		} catch (e) {
		}

		return false;
	},

	onContentChange : function () {
		if (!content.document){
			// This will be caught by the oncontentload function once it loads.
			this.showResults(null, "");
			return;
		}
		
		var url = content.document.location.href;
		
		if (MHOS_DEBUG) logMhoShareMsg("Content change: " + url);
		this.onContentLoad({ 'target' : content.document }, true);
		
		return;
	},

	showRelated : function (url, serp) {
		if (MHOS_DEBUG) logMhoShareMsg("In showRelated: " + url + " " + serp);
		
		if (url != this.currentPage && url == content.document.location.href) {
			this.currentPage = url;
			
			var sidebarUrl = this.followService;
			if (serp) sidebarUrl += "?serp=" + encodeURIComponent(serp);
	
			if (MHOS_DEBUG) {
				logMhoShareMsg("Showing matches for SERP page in sidebar for " + url);
				logMhoShareMsg("Sidebar URL is now " + sidebarUrl);
			}
			
			this.browser.webNavigation.loadURI(sidebarUrl, Components.interfaces.nsIWebNavigation.LOAD_FLAGS_NONE, null, null, null);
		}
	},

	showResults : function (url, keywords, isSearch) {
		if (!url || (url != this.currentPage && this.browser && url == content.document.location.href)) {
			this.currentPage = url;
			var host = '';
		
			try {
				var host = url.split("//")[1].split("/")[0];
			} catch (e) { }
		
			if (isSearch) {
				isSearch = 1;
			}
			else {
				isSearch = 0;
			}
			
			var sidebarUrl = this.followService + "?";
			if (MHOS_DEBUG) sidebarUrl += "rand="+(Math.round(Math.random() * 89999) + 10000)+"&";
			sidebarUrl += "h="+window.innerHeight+"&keywords="+encodeURIComponent(keywords) + "&isSearch=" + isSearch;	
			if (host != '') sidebarUrl += "&host=" + encodeURIComponent(host);
			
			if (MHOS_DEBUG) {
				logMhoShareMsg("Showing matches in sidebar for " + url + " (" + keywords + ")");
				logMhoShareMsg("Sidebar URL is now " + sidebarUrl);
			}

			this.browser.webNavigation.loadURI(sidebarUrl, Components.interfaces.nsIWebNavigation.LOAD_FLAGS_NONE, null, null, null);  
			
			if (isSearch && host != '') {
				MHO_SHARE_API.send_comparison(host);
			}
		}
	},
	
	isMahaloShare : function () {
		// This doesn't look like it makes sense, but the build script
		// for Mahalo Share replaces 'mahalo-share' in the code
		// with 'mahalo-share'. 
		var string1 = "mahalo-" + "share";
		var string2 = "mahalo-share";
		return (string1 === string2);
	}
};

addEventListener("load", function (event) { MHO_SHARE.init(event); }, false);