var MHOS_LINKCHECK = {
	prefs : Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.mahalo.share."),
	
	init : function () {
		var appcontent = document.getElementById("appcontent");

		if (appcontent) {
			appcontent.addEventListener("DOMContentLoaded", function (event) { MHOS_LINKCHECK.contentLoad(event); }, false);
		}
	},
	
	contentLoad : function (event) {
		var page = event.target;
	
		if (page.location.href.match(/^https?:\/\/[^\/]*google.[^\/]+\/search/)) {
			// Google search.
			if (MHOS_LINKCHECK.prefs.getBoolPref("validateSearchResults")) {
				var linkIterator = page.evaluate("//div[@class='g']//a[@class='l']", page, null, XPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
				var links = [];
				
				var link = linkIterator.iterateNext();
			
				while (link) {
					links.push({ "node" : link, "href" : link.href });
					link = linkIterator.iterateNext();
				}
			
				this.checkLinks(page, links);
			}
			
			if (this.prefs.getBoolPref("search.showTop7") || this.prefs.getBoolPref("search.showGuideNote")) {
				this.checkTop7(page);
			}
		}
		else if (page.location.href.match(/^https?:\/\/[^\/]*yahoo.[^\/]+\/search/)) {
			// Yahoo search.
			if (this.prefs.getBoolPref("validateSearchResults")) {
				var linkIterator = page.evaluate("//div[@id='web']//ol//a[@class='yschttl']", page, null, XPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
				var links = [];
				
				var link = linkIterator.iterateNext();
			
				while (link) {
					links.push({ "node" : link, "href" : decodeURIComponent(link.href.split("**")[1]) });
					link = linkIterator.iterateNext();
				}
			
				this.checkLinks(page, links);
			}
			
			if (this.prefs.getBoolPref("search.showTop7") || this.prefs.getBoolPref("search.showGuideNote")) {
				this.checkTop7(page);
			}
		}
		else if (page.location.href.match(/https?:\/\/[^\/]*search\.(live|msn)\.[^\/]+\/results/)) {
			// MSN Search
			if (this.prefs.getBoolPref("validateSearchResults")) {
				var linkIterator = page.evaluate("//div[@id='results']/ul/li/h3/a", page, null, XPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
				var links = [];
				
				var link = linkIterator.iterateNext();
			
				while (link) {
					links.push({ "node" : link, "href" : link.href });
					link = linkIterator.iterateNext();
				}
			
				this.checkLinks(page, links);
			}
			
			if (this.prefs.getBoolPref("search.showTop7") || this.prefs.getBoolPref("search.showGuideNote")) {
				this.checkTop7(page);
			}
		}
		else if (page.location.href.match(/https?:\/\/www\.ask\.[^\/]+\/web/)) {
			// Ask.com search
			if (this.prefs.getBoolPref("validateSearchResults")) {
				var linkIterator = page.evaluate("//div[@id='teoma-results']/div/div/div/table//td/a", page, null, XPathResult.ORDERED_NODE_ITERATOR_TYPE, null);
				var links = [];
				
				var link = linkIterator.iterateNext();
			
				while (link) {
					if (link.innerHTML.replace(/<[^>]+>/g, "").replace(/\s/g, "") != '') {
						links.push({ "node" : link, "href" : link.href });
					}
					
					link = linkIterator.iterateNext();
				}
			
				this.checkLinks(page, links);
			}
			
			if (this.prefs.getBoolPref("search.showTop7") || this.prefs.getBoolPref("search.showGuideNote")) {
				this.checkTop7(page);
			}
		}
	},
	
	checkLinks : function (page, links) {
		var templateNode = page.createElement("a");
		templateNode.href = 'http://www.mahalo.com/';
		templateNode.style.paddingLeft = '1ex';
		
		var image = page.createElement("img");
		image.setAttribute("border","0");
		image.src = "chrome://mahalo-share/skin/flower16.png";
		image.setAttribute("alt","Approved by Mahalo!");
		image.setAttribute("title","Approved by Mahalo!");
		
		templateNode.appendChild(image);
		
		var req = new XMLHttpRequest();
		var url = this.prefs.getCharPref("uris.api.linkCheck") + "?action=linkcheck&format=xml";
		req.open("POST", url, true);
		req.overrideMimeType("text/xml");
		
		var argstring = "";
		
		for (var i = 0; i < links.length; i++) {
			argstring += 'uris[]=' + encodeURIComponent(links[i].href) + '&';
		}
		
		req.setRequestHeader("Content-Type","application/x-www-form-urlencoded");
		req.setRequestHeader("Content-Length", argstring.length);
		req.parent = this;
		
		req.onreadystatechange = function (event) {
			if (req.readyState == 4) {
				try {
					var xml = req.responseXML;

					var linkCheckRoot = MHOS_LINKCHECK.prefs.getCharPref("uris.home");
					
					// Get a list of the URIs that were returned.
					var results = xml.getElementsByTagName("uri");
					
					for (var i = 0; i < results.length; i++){
						var result = results[i];
						
						// Check if any pages contain this URI
						var pages = result.getElementsByTagName("page");
						
						if (pages.length > 0) {
							var href = result.getAttribute("href");
							var node = null;
							
							// Find the <A> element in the page that corresponds to this HREF
							for (var j = 0; j < links.length; j++){
								if (links[j].href == href) {
									node = links[j];
									break;
								}
							}
							
							if (node) {
								// Add a link for each page the URI is linked from
								for (var j = 0; j < pages.length; j++){
									var title = pages[j].getAttribute("title").replace(/_/g, " ");
									var textLink = page.createElement("a");
									textLink.href = linkCheckRoot + pages[j].getAttribute("title");
									textLink.appendChild(page.createTextNode(title));
									textLink.style.fontSize = '70%';
									textLink.style.textDecoration = 'none';
									textLink.style.backgroundImage = "url('chrome://mahalo-share/skin/flower16.png')";
									textLink.style.paddingLeft = '18px';
									textLink.style.marginLeft = '1ex';
									textLink.style.backgroundRepeat = "no-repeat";
									node.node.parentNode.insertBefore(textLink, node.node.nextSibling);
								}
							}
						}
					}
				} catch (e) {
					throw(e);
				}
			}
		};
		
		req.send(argstring);
	},
	
	checkTop7 : function (page) {
		var term = page.location.href.match(/[\?&](q|p|w|wd|query|search|search_query|satitle)=([^&]+)/i)[2];
		term = term.charAt(0).toUpperCase() + term.substring(1).toLowerCase();
		
		var req = new XMLHttpRequest();
		var url = this.prefs.getCharPref("uris.api.linkCheck") + "?format=json&action=query&redirects=1&%74itles=" + term;
		
		req.open("GET", url, true);
		
		req.onreadystatechange = function () {
			if (req.readyState == 4) {
				var json = eval("(" + req.responseText + ")");
				var results = json.query.pages;
				
				for (var i in results) {
					var result = results[i];
					break;
				}

				if (result.pageid != 0) {
					if (!result.title.match(/^Category:/)) {
						if (MHOS_LINKCHECK.prefs.getBoolPref("search.showTop7")) MHOS_LINKCHECK.injectTop7(page, result.title);
						if (MHOS_LINKCHECK.prefs.getBoolPref("search.showGuideNote")) MHOS_LINKCHECK.injectGuideNote(page, result.title);
					}
				}
			}
		};
		
		req.send(null);
	},
	
	injectTop7 : function (page, title) {
		var url = "http://www.mahalo.com/" + title.replace(/\s/g, "_") + "?action=json";
		
		var req = new XMLHttpRequest();
		req.open("GET", url, true);
		
		req.onreadystatechange = function () {
			if (req.readyState == 4){
				var data = req.responseText;
				
				var json = eval("(" + data + ")");
				
				for (var i in json) {
					var serp = json[i];
					break;
				}
				
				var sections = serp["sections"];
				
				for (var i = 0; i < sections.length; i++) {
					if (sections[i]["name"].match(/Top (7|Seven)/i)) {
						var top7 = sections[i]["html"];
						break;
					}
				}
				
				if (top7) {
					if (page.location.href.match(/^https?:\/\/[^\/]*google.[^\/]+\/search/)) {
						var buf = '<div class="g"><a class="l" href="http://www.mahalo.com/'+title+'" style="padding-left: 18px; background-image: url(\'chrome://mahalo-share/skin/flower16.png\'); background-repeat: no-repeat;">Mahalo Top 7 for <b>'+title+'</b></a><ul style="font-size: 90%; list-style-type: none !important; padding-left: 1em;">';
					
						var limit = 7;
						var count = 1;
						
						for (var i = 0; i < top7.length && i < limit; i++){
							// Get rid of shakas, warnings, etc.
							top7[i] = top7[i].replace(/<img[^>]+src="[^"]+transparent[^"]+"[^>]+>/gi, "");
							
							// Get rid of forced whitespace
							top7[i] = top7[i].replace(/&nbsp;/g, " ");
							
							// Only add items that contain a link.
							if (!top7[i].match(/<script/i) && top7[i].match(/<a\s/i)) {
								buf += '<li>' + (count++) + '. ' + top7[i].replace(/<\/?p[^>]*>/g, "") + '</li>';
							}
							else {
								limit++;
							}
						}
					
						buf += '</ul></div>';
						
						switch (MHOS_LINKCHECK.prefs.getIntPref("search.showTop7.location")) {
							case 1:
								// Above the main results
								// Find the results divs
								var results = page.getElementById("res");
				
								for (var i = 0; i < results.childNodes.length; i++) {
									if (results.childNodes[i].nodeName == 'DIV' && !results.childNodes[i].id) {
										results = results.childNodes[i];
										break;
									}
								}
				
								var newDiv = page.createElement("div");
								newDiv.innerHTML = buf;
					
								results.insertBefore(newDiv, results.firstChild);
							break;
							case 2:
								// Above the ads.
								var ads = MHOS_LINKCHECK.getGoogleAdSection(page);
								
								// Insert above ads.
								var tr = page.createElement("tr")
								var td = page.createElement("td");
								td.innerHTML = buf;
								tr.appendChild(td);
								
								var adTableBody = ads.getElementsByTagName("tbody")[0];
								
								adTableBody.insertBefore(tr, adTableBody.firstChild);
							break;
						}
					}
					else if (page.location.href.match(/^https?:\/\/[^\/]*yahoo.[^\/]+\/search/)) {
						// It will be the first child of <Div id="east">
						
						var buf = '<ul><li><a href="http://www.mahalo.com/'+title+'" style="white-space: nowrap; padding-left: 18px; background-image: url(\'chrome://mahalo-share/skin/flower16.png\'); background-repeat: no-repeat; font-size: 123%;">Mahalo Top 7 for <b>'+title+'</b></a><ol style="padding-left: 50px; padding-bottom: 0px;">';
					
						var limit = 7;
						
						for (var i = 0; i < top7.text.length && i < limit; i++){
							// Get rid of shakas, warnings, etc.
							top7[i] = top7[i].replace(/<img[^>]+src="[^"]+transparent[^"]+"[^>]+>/gi, "");
							
							// Get rid of forced whitespace
							top7[i] = top7[i].replace(/&nbsp;/g, " ");
							
							// Only add items that contain a link.
							if (!top7[i].match(/<script/i) && top7[i].match(/<a\s/i)) {
								top7[i] = top7[i].replace(/<a/ig, "<a style='display: inline; margin: 0; font-size: 100%; line-height: 1em; color: #0000de;'");
								top7[i] = top7[i].replace(/<li/ig, "<li style='padding: 2px 0px 2px 0px; border: 0; margin-bottom: 0;'");
								buf += '<li style="list-style-type: decimal; padding-bottom: 2px; padding-top: 2px; border: 0; margin-bottom: 0;">'+top7[i].replace(/<\/?p[^>]*>/g, "") + '</li>';
							}
							else {
								limit++;
							}
						}
					
						buf += '</ol></li></ul>';
						
						var div = page.createElement("div");
						div.innerHTML = buf;
						
						switch (MHOS_LINKCHECK.prefs.getIntPref("search.showTop7.location")) {
							case 1:
								// Above the main results
								page.getElementById("web").insertBefore(div, page.getElementById("web").firstChild);
							break;
							case 2:
								// Above the ads.
								
								// Are there ads?
								var ads = page.getElementById("east");
								
								if (!ads) {
									// No
										// Create the ads div
										
									var ads = page.createElement("div");
									ads.setAttribute("id","east");
									ads.appendChild(div);
									page.getElementById('results').insertBefore(ads, page.getElementById("pg"));
								}
								else {
									// Insert above ads.
									ads.insertBefore(div, ads.firstChild);
								}
							break;
						}
					}
					else if (page.location.href.match(/https?:\/\/[^\/]*search\.(live|msn)\.[^\/]+\/results/)) {
						var buf = '<ul style="margin-bottom: 10px;"><li><a href="http://www.mahalo.com/'+title+'" style="white-space: nowrap; padding-left: 18px; padding-top: 0; background-image: url(\'chrome://mahalo-share/skin/flower16.png\'); background-repeat: no-repeat; font-size: 123%;">Mahalo Top 7 for <b>'+title+'</b></a><ol style="padding-left: 40px; padding-bottom: 0px;">';
					
						var limit = 7;
						
						for (var i = 0; i < top7.text.length && i < limit; i++){
							// Get rid of shakas, warnings, etc.
							top7[i] = top7[i].replace(/<img[^>]+src="[^"]+transparent[^"]+"[^>]+>/gi, "");
							
							// Get rid of forced whitespace
							top7[i] = top7[i].replace(/&nbsp;/g, " ");
							
							// Only add items that contain a link.
							if (!top7[i].match(/<script/i) && top7[i].match(/<a\s/i)) {
								top7[i] = top7[i].replace(/<a/ig, "<a style='display: inline; margin: 0; font-size: 100%; line-height: 1em; color: #0000de;'");
								top7[i] = top7[i].replace(/<li/ig, "<li style='padding: 2px 0px 2px 0px; border: 0; margin-bottom: 0;'");
								buf += '<li style="list-style-type: decimal; padding-bottom: 2px; padding-top: 2px; border: 0; margin-bottom: 0; margin-top: 0;">'+top7[i].replace(/<\/?p[^>]*>/g, "") + '</li>';
							}
							else {
								limit++;
							}
						}
					
						buf += '</ol></li></ul>';
						
						var div = page.createElement("div");
						div.innerHTML = buf;
						
						switch (MHOS_LINKCHECK.prefs.getIntPref("search.showTop7.location")) {
							case 1:
								// Above the main results
								page.getElementById("results").insertBefore(div, page.getElementById("results").firstChild);
							break;
							case 2:
								// Above the ads.
								
								// Are there ads?
								var ads = page.getElementById("ar");
								
								if (!ads) {
									// No
										// Create the ads div
										
									var ads = page.createElement("div");
									ads.setAttribute("id","sidebar");
									ads.innerHTML = '<div id="ar">' + buf + '</div>';
									page.getElementById('content').insertBefore(ads, page.getElementById("pag"));
								}
								else {
									// Insert above ads.
									ads.insertBefore(div, ads.firstChild);
								}
							break;
						}
					}
					else if (page.location.href.match(/https?:\/\/www\.ask\.[^\/]+\/web/)) {
						var buf = '<div style="margin-bottom: 10px;"><p><a href="http://www.mahalo.com/'+title+'" style="white-space: nowrap; padding-left: 18px; padding-top: 0; background-image: url(\'chrome://mahalo-share/skin/flower16.png\'); color: #00c; background-repeat: no-repeat; font-size: 123%;">Mahalo Top 7 for <b>'+title+'</b></a></p><ol style="padding-left: 40px; padding-bottom: 0px;">';
					
						var limit = 7;
						
						for (var i = 0; i < top7.text.length && i < limit; i++){
							// Get rid of shakas, warnings, etc.
							top7[i] = top7[i].replace(/<img[^>]+src="[^"]+transparent[^"]+"[^>]+>/gi, "");
							
							// Get rid of forced whitespace
							top7[i] = top7[i].replace(/&nbsp;/g, " ");
							
							// Only add items that contain a link.
							if (!top7[i].match(/<script/i) && top7[i].match(/<a\s/i)) {
								top7[i] = top7[i].replace(/<a/ig, "<a style='display: inline; margin: 0; font-size: 100%; line-height: 1em; color: #00c;'");
								top7[i] = top7[i].replace(/<li/ig, "<li style='padding: 2px 0px 2px 0px; border: 0; margin-bottom: 0;'");
								buf += '<li style="list-style-type: decimal; padding-bottom: 2px; padding-top: 2px; border: 0; margin-bottom: 0; margin-top: 0;">'+top7[i].replace(/<\/?p[^>]*>/g, "") + '</li>';
							}
							else {
								limit++;
							}
						}
					
						buf += '</ol></div>';
						
						var div = page.createElement("div");
						div.innerHTML = buf;
						
						switch (MHOS_LINKCHECK.prefs.getIntPref("search.showTop7.location")) {
							case 1:
								// Above the main results
								div.style.borderBottom = "1px solid #c1c1c1";
								div.style.borderTop = "1px solid #c1c1c1";
								
								page.getElementById("teoma-results").insertBefore(div, page.getElementById("teoma-results").firstChild);
							break;
							case 2:
								div.style.borderBottom = "1px solid #c1c1c1";
								page.getElementById("content").insertBefore(div, page.getElementById("filters"));
							break;
						}
					}
				}
			}
		}
		
		req.send(null);
	},
	
	injectGuideNote : function (page, title) {
		var req = new XMLHttpRequest();
		var url = MHOS_LINKCHECK.prefs.getCharPref("uris.api.note") + "?page_title=" + title.replace(/_/g, " ");
		title = title.split(" ").map( function (item) { return item.substring(0, 1).toUpperCase() + item.substring(1); } ).join(" ");
		req.open("GET", url, true);
		
		req.onreadystatechange = function () {
			if (req.readyState == 4){
				
				var buf = req.responseText;
				
				if (!buf.match(/mahalo_note/)) {
				    return;
				}
				
				buf = buf.replace(/"#cite_note/g, "\"http://www.mahalo.com/"+title+"#guide_note");
				//buf = buf.replace(/http:\/\/content\.mahalo\.com\/skin/ig, "http://localhost/skin");
				buf = buf.replace(/(Guide|Member) [Nn]ote:?/, '<a href="http://www.mahalo.com/'+title+'" style="color: inherit !important; font-size: inherit !important; text-decoration: none;">'+title+'</a>');
				buf = buf.replace(/<\/div>$/i, '<div class="readmore"><a href="http://www.mahalo.com/'+title+'">Continue Reading...</a></div></div>');
				
				if (page.location.href.match(/^https?:\/\/[^\/]*google.[^\/]+\/search/)) {
    				// Are there ads?
					var ads = MHOS_LINKCHECK.getGoogleAdSection(page);

   					// Insert above ads.
   					var tr = page.createElement("tr")
   					var td = page.createElement("td");
   					// td.style.paddingTop = '10px';
   					td.innerHTML = buf;
				
   					tr.appendChild(td);
				
   					var adTableBody = ads.getElementsByTagName("tbody")[0];
				
   					adTableBody.insertBefore(tr, adTableBody.firstChild);
    			}
				else if (page.location.href.match(/^https?:\/\/[^\/]*yahoo.[^\/]+\/search/)) {
					// It will be the first child of <Div id="east">
					
					var div = page.createElement("div");
					div.innerHTML = buf;
					
					// Are there ads?
					var ads = page.getElementById("east");
					
					if (!ads) {
						// No
							// Create the ads div
							
						var ads = page.createElement("div");
						ads.setAttribute("id","east");
						ads.appendChild(div);
						page.getElementById('results').insertBefore(ads, page.getElementById("pg"));
					}
					else {
						// Insert above ads.
						ads.insertBefore(div, ads.firstChild);
					}
				}
				else if (page.location.href.match(/https?:\/\/[^\/]*search\.(live|msn)\.[^\/]+\/results/)) {
					var div = page.createElement("div");
					div.innerHTML = buf;
					
					// Are there ads?
					var ads = page.getElementById("sidebar");
					
					if (!ads) {
						// No
							// Create the ads div
							
						var ads = page.createElement("div");
						ads.setAttribute("id","sidebar");
						ads.innerHTML = '<div id="sidebar">' + buf + '</div>';
						page.getElementById('content').insertBefore(ads, page.getElementById("pag"));
					}
					else {
						// Insert above ads.
						ads.insertBefore(div, ads.firstChild);
					}
				}
				else if (page.location.href.match(/https?:\/\/www\.ask\.[^\/]+\/web/)) {
					var div = page.createElement("div");
					div.innerHTML = buf;
					page.getElementById("rightRail").insertBefore(div, page.getElementById("rightRail").firstChild);
				}
			}
		};
		
		req.send(null);
	},
	
	getGoogleAdSection : function (page) {
		var ads = page.getElementById("mbEnd");
		
		if (!ads) {
			ads = page.createElement("table");
			ads.setAttribute("id", "mbEnd");
			ads.setAttribute("class", "ra");
			ads.setAttribute("width", "25%");
			ads.setAttribute("align","right");
		
			var tbody = page.createElement("tbody");
			var tr = page.createElement("tr")
		
			var td1 = page.createElement("td");
			td1.setAttribute("rowspan", "100");
			td1.setAttribute("id", "rhsline");
		
			var td2 = page.createElement("td");
			td2.setAttribute("width","1");
			td2.setAttribute("bgcolor", "#c9d7f1");
			td2.setAttribute("rowspan","100");
			td2.style.padding = "0";
		
			var img = page.createElement("img");
			img.setAttribute("width","1");
			img.setAttribute("height","1");
			img.setAttribute("alt", "");
		
			td2.appendChild(img);
		
			var td3 = page.createElement("td");
			td3.setAttribute("rowspan","100");
		
			var td4 = page.createElement("td");
			td4.setAttribute("class","std");
			td4.innerHTML = " ";
		
			tr.appendChild(td1);
			tr.appendChild(td2);
			tr.appendChild(td3);
			tr.appendChild(td4);
		
			tbody.appendChild(tr);
			ads.appendChild(tbody);
		
			var results = page.getElementById("res");

			for (var i = 0; i < results.childNodes.length; i++) {
				if (results.childNodes[i].nodeName == 'DIV' && !results.childNodes[i].id) {
					results = results.childNodes[i];
					break;
				}
			}
		
			results.parentNode.insertBefore(ads, results);
		}
		
		return ads;
	}
};

window.addEventListener("load", function () { MHOS_LINKCHECK.init(); }, false);