var MHO_SHARE_PREFS = {
	objName : "MHO_SHARE_PREFS",
	instantApply : false,
	
	get browserPrefs() { return Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("browser.preferences."); },
	
	load : function () {
		this.instantApply = this.browserPrefs.getBoolPref("instantApply");
		
		if (!this.instantApply) {
			this.browserPrefs.setBoolPref("instantApply", true);
		}
		
		var BM_OBJECT = MHO_SHARE_BOOKMARKING;
		var API_OBJECT = MHO_SHARE_API;
		
		var serviceList = document.getElementById("service-list");
		var serviceDeck = document.getElementById("bookmarking-settings");
		var templateNode = document.getElementById("service-template");
		var auths = {};
		
		if (API_OBJECT.bmPrefs.getBoolPref("remoteLogins")) {
			var auths = BM_OBJECT.getAllRemoteLogins();
			logMhoShareMsg(auths);
		}
		
		for (var i = 0; i < BM_OBJECT.services.length; i++){
			var service = BM_OBJECT.services[i];
			
			var serviceOption = document.createElement("menuitem");
			serviceOption.setAttribute("id", "service-option-" + service);
			serviceOption.setAttribute("label", BM_OBJECT.serviceData[service].name);
			
			serviceList.appendChild(serviceOption);
			
			var servicePane = templateNode.cloneNode(true);
			servicePane.id = "service-" + service;
			servicePane.style.visibility = '';
			servicePane.getElementsByTagName("image")[0].id = "logo-" + service;
			servicePane.getElementsByTagName("textbox")[0].id = "username-" + service;
			servicePane.getElementsByTagName("textbox")[1].id = "password-" + service;
			servicePane.getElementsByTagName("checkbox")[0].id = "checkbox-" + service;
			servicePane.getElementsByTagName("button")[0].id = "button-" + service;
			servicePane.getElementsByTagName("label")[0].id = "username-label-" + service;
			servicePane.getElementsByTagName("label")[1].id = "password-label-" + service;
			
			serviceDeck.appendChild(servicePane);
			
			document.getElementById("checkbox-" + service).setAttribute("label","Share links on " + BM_OBJECT.serviceData[service].name);
			document.getElementById("checkbox-" + service).setAttribute("oncommand","if (!this.checked) { "+this.objName+".clearLogin('"+service+"'); }");
			document.getElementById("button-" + service).setAttribute("oncommand",this.objName+".authChange('"+service+"');");
			document.getElementById("username-label-" + service).setAttribute("value",BM_OBJECT.serviceData[service].usernameLabel + ":");
			
			if ("passwordLabel" in BM_OBJECT.serviceData[service]) {
				document.getElementById("password-label-" + service).setAttribute("value", BM_OBJECT.serviceData[service].passwordLabel + ":");
			}
			
			if (API_OBJECT.bmPrefs.getBoolPref("bookmarkServices." + service)) {
				document.getElementById("checkbox-" + service).checked = true;
				
				if (!auths[service]) {
					var auth = API_OBJECT[service].auth;
				}
				else {
					var auth = auths[service];
				}
				
				document.getElementById("username-" + service).value = auth.username;
				document.getElementById("password-" + service).value = auth.password;
			}
		}
		
		serviceList.parentNode.selectedIndex = 0;
		
		templateNode.parentNode.removeChild(templateNode);
		
		API_OBJECT.bmPrefs.setBoolPref("hasSetupBookmarkServices", true);
	},
	
	unload : function () {
		if (!this.instantApply) {
			this.browserPrefs.setBoolPref("instantApply", false);
		}
	},
	
	unService : function (service) {
		MHO_SHARE_API.bmPrefs.setBoolPref("bookmarkServices." + service, false);
		
		var loginUrl = "http://" + service + ".mahalo.com/";
		
		MHO_SHARE_BOOKMARKING.removeLogin(loginUrl);
	},
	
	clearLogin : function (service) {
		document.getElementById("username-" + service).value = '';
		document.getElementById("password-" + service).value = '';
		
		this.unService(service);
	},
	
	authChange : function (service) {
		var username = document.getElementById("username-" + service).value;
		var password = document.getElementById("password-" + service).value;
		
		if (username && password) {
			MHO_SHARE_BOOKMARKING.serviceData[service].authenticated = false;

			// Authenticate.
			document.getElementById("authdeck").selectedIndex = 1;
			document.getElementById("auth-loading").style.visibility = '';
			
			MHO_SHARE_API[service].checkLogin(username, password, function (service) { MHO_SHARE_PREFS.authSucceeded(service); }, function (service) { MHO_SHARE_PREFS.authFailed(service); });
		}
	},
	
	authFailed : function (service) {
		MHO_SHARE_BOOKMARKING.serviceData[service].authenticated = false;
		
		document.getElementById("authdeck").selectedIndex = 2;
		document.getElementById("auth-loading").style.visibility = 'hidden';
		
		this.unService(service);
	},
	
	authSucceeded : function (service) {
		MHO_SHARE_BOOKMARKING.serviceData[service].authenticated = true;
		
		document.getElementById("authdeck").selectedIndex = 3;
		document.getElementById("auth-loading").style.visibility = 'hidden';
		
		// Save it.
		this.saveService(service);
	},
	
	saveService : function (service) {
		if (!MHO_SHARE_API.bmPrefs.getBoolPref("remoteLogins")) {
			this.unService(service);
		}
		
		var loginUrl = "http://" + service + ".mahalo.com/";
		var username = document.getElementById("username-" + service).value;
		var password = document.getElementById("password-" + service).value;
		
		if (username && password) {
			MHO_SHARE_BOOKMARKING.addLogin(loginUrl, username, password);
		
			MHO_SHARE_API.bmPrefs.setBoolPref("bookmarkServices." + service, true);
		}
	}
};