var MHO_SHARE_TOOLBAR = {
	// Stores the accumulated page ratings the user has made.  Populated at the
	// beginning of the browser session, dumped to mho-ratings at the end.
	ratings : [],
	
	opmldoc : null,
	
	// The last page that was used to change the state of the ratings buttons.
	lastPage : null,
	
	get search_field() { return document.getElementById("mho-share-search"); },
	get categoriesMenu() { return document.getElementById("mho-share-directory-popup"); },
	get prefs() { return Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.mahalo.share."); }, 
	get bmPrefs() { return Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.mahalo.bookmarking."); }, 
	get mhoPrefs() { return Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.mahalo."); }, 
	
	get profilePath() {
		var DIR_SERVICE = new Components.Constructor("@mozilla.org/file/directory_service;1", "nsIProperties");
		var profilePath = (new DIR_SERVICE()).get("ProfD", Components.interfaces.nsIFile).path; 
		
		if (profilePath.search(/\\/) != -1) profilePath += "\\";
		else profilePath += "/";
		
		return profilePath;
	},
	
	shareOpener : null,
	
	toolbarsCustomized : function (event) {
		// For now, set this every time so that our button text still appears
		try { document.getElementById("mahalo-share-toolbar").setAttribute("mode", "full"); } catch (toolbarNotThere) { }
		
		// Add url-related data to toolbar buttons
		if (document.getElementById("mho-share-logo-button")) document.getElementById('mho-share-logo-button').setAttribute("oncommand","if (event.target == this) { mhos_launchUrl('" + MHO_SHARE.prefs.getCharPref("uris.home") + "'); }");
		if (document.getElementById("share-go-to-mahalo-button")) document.getElementById('share-go-to-mahalo-button').setAttribute("oncommand","mhos_launchUrl('" + MHO_SHARE.prefs.getCharPref("uris.home") + "');");
		if (document.getElementById("share-go-to-mahalo-greenhouse-button")) document.getElementById('share-go-to-mahalo-greenhouse-button').setAttribute("oncommand","mhos_launchUrl('" + MHO_SHARE.prefs.getCharPref("uris.greenhouse") + "');");
		if (document.getElementById("mho-share-random-button")) document.getElementById('mho-share-random-button').setAttribute("oncommand","mhos_launchUrl('" + MHO_SHARE.prefs.getCharPref("uris.random") + "');");
		
		if (this.mhoPrefs.getCharPref("username") != '') {
			// Enable the menus.
			if (document.getElementById("mho-share-my-links-button")) {
				document.getElementById("mho-share-my-links-button").disabled = false;
			}
			
			if (document.getElementById("mho-share-my-friends-links-button")) {
				document.getElementById("mho-share-my-friends-links-button").disabled = false;
			}
		}
		
		this.getCategoryList();		
	},
	
	// GENERAL: load, unload, etc.
	
	load : function () {
		var prefs = this.prefs;
		
		// Called on window load.
		document.getElementById("cmd_CustomizeToolbars").addEventListener("DOMAttrModified", function(aEvent) { if (aEvent.attrName == 'disabled') { MHO_SHARE_TOOLBAR.toolbarsCustomized(aEvent); } }, false);
		
		this.toolbarsCustomized();
		
		// Check if this is the first time running a build with the del.icio.us integration.
		var otherPrefBranch = (!MHO_SHARE.isMahaloShare()) ? "share" : "follow";
		
		if (!this.bmPrefs.getBoolPref("hasSetupBookmarkServices")) {
			var prefVal = false;
			
			// Check for bookmarking stuff from old versions of Follow or Share
			try {
				prefVal = prefVal || this.prefs.getBoolPref("hasSetupBookmarkServices");
			} catch (noWorries) {  }
			
			if (!prefVal) {
				try {
					prefVal = prefVal || this.mhoPrefs.getBoolPref(otherPrefBranch + ".hasSetupBookmarkServices");
				} catch (noWorries) {  }
			}
			
			if (prefVal) {
				this.bmPrefs.setBoolPref("hasSetupBookmarkServices", prefVal);
			}
			
			if (!this.bmPrefs.getBoolPref("hasSetupBookmarkServices")) {
				logMhoShareMsg("Opening a window...");
				window.open("chrome://mahalo-share/content/bookmark-service-wizard.xul", "mahalo-share-bookmark-wizard", "chrome,centerscreen=yes");
			}
		}
		
		if (!this.mhoPrefs.getCharPref("username")) {
			var username = '';
			try {
				username = this.prefs.getCharPref("username");
			} catch (e) { }
			
			if (!username) {
				try {
					username = this.mhoPrefs.getCharPref(otherPrefBranch + ".username");
				} catch (e) { }
			}
			
			if (username) {
				this.mhoPrefs.setCharPref("username", username);
			}
		}
		
		// Check for any Mahalo cookies so we can get their username for the "my links" list.
		var ios = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
		var uri = ios.newURI(MHO_SHARE.prefs.getCharPref("uris.referralCookieDomain"), null, null);
		var cookieSvc = Components.classes["@mozilla.org/cookieService;1"].getService(Components.interfaces.nsICookieService);
		var cookieString = cookieSvc.getCookieString(uri, null);
		var foundIt = false;
		
		if (cookieString) {
			var cookies = cookieString.split(";");
	
			for (var i = 0; i < cookies.length; i++){
				if (cookies[i].match(/wikidbUserName/gi)) {
					var username = cookies[i].split("=")[1];
					this.mhoPrefs.setCharPref("username",username);
					break;
				}
			}
		}

		this.getRatingsList();

		try {
			// Uninstall Mahalo Follow if it is present.
			var em = Components.classes["@mozilla.org/extensions/manager;1"].getService(Components.interfaces.nsIExtensionManager);
			var loc = em.getInstallLocation("follow@mahalo.com");
			
			if (loc) {
				if (!document.getElementById("mahalo-follow-toolbar").collapsed) {
					document.getElementById("mahalo-share-toolbar").collapsed = false;
					document.getElementById("mahalo-follow-toolbar").collapsed = true;
				}
				
				em.uninstallItem("follow@mahalo.com");
				setTimeout(this.restartForUpgrade, 3000);
			}
		} catch (followNotInstalled) {
		}
	},
	
	restartForUpgrade : function () {
		var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
		                        .getService(Components.interfaces.nsIPromptService);
		var check = { value : false };
		var flags = prompts.BUTTON_POS_0 * prompts.BUTTON_TITLE_IS_STRING + 
					prompts.BUTTON_POS_1 * prompts.BUTTON_TITLE_IS_STRING;
		var button = prompts.confirmEx(window, 
					"Complete Mahalo Share Upgrade", 
					"Your browser must be restarted to complete the upgrade process for Mahalo Share (formerly Mahalo Follow).", 
					flags, 
					"Restart Now", 
					"Restart Later", 
					"", null, check);
		
		if (button == 0) {
			var service = Components.interfaces.nsIAppStartup;
			
			Components.classes["@mozilla.org/toolkit/app-startup;1"].getService(service).quit(service.eRestart | service.eAttemptQuit);
		}
	},
	
	onMyEvent : function (event) {
		var mydata = event.target.passedData;
		
		var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
		var enumerator = wm.getEnumerator(null);

		while(enumerator.hasMoreElements()) {
			var win = enumerator.getNext();

			if (win.MHO_SHARE_TOOLBAR && win.MHO_SHARE_TOOLBAR.shareOpener) {
				win.MHO_SHARE_TOOLBAR.shareOpener.gBrowser.selectedTab = win.MHO_SHARE_TOOLBAR.shareOpener.gBrowser.addTab(mydata.url);
				win.MHO_SHARE_TOOLBAR.shareOpener = null;
				return;
			}
		}
	},
	
	unload : function (event) {
		// Called on window closing
		
		this.saveRatingsList();
	},
	
	contentChange : function (event) {
		try {
			var page = content.document.location.href;
		} catch (e) {
			// Disable it
			return;
		}
		
		if (this.lastPage == page) {
			return;
		}
		
		this.updateRatingButtons(-1);
		
		this.lastPage = page;
		
		// Check for rating in ratings file
		for (var i = 0; i < this.ratings.length; i++){
			if (this.ratings[i].url == page) {
				this.updateRatingButtons(this.ratings[i].score);
				break;
			}
		}
	},
	
	// All-purpose: IO, logging, etc.
	
	writeBytes : function (outputStream, data) {
		var bytes, bytesWritten, bytesRemaining = data.length;
		var offset = 0;
		
		while (bytesRemaining) {
			bytesWritten = outputStream.write(data.substring(offset), bytesRemaining);
			bytesRemaining -= bytesWritten;
			offset += bytesWritten;
		}
	},
	
	saveToProfile : function (filename, xml) {
		var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
		file.initWithPath(this.profilePath + filename);

		var outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance( Components.interfaces.nsIFileOutputStream );

		outputStream.init(file, 0x02 | 0x08 | 0x20, 0600, null);
		(new XMLSerializer()).serializeToStream(xml, outputStream, xml.characterSet);
			
		outputStream.close();
	},
	
	// Directory Dropdown
	
	getCategoryList : function (force) {
		if (document.getElementById("mho-share-random-menu") || document.getElementById("mho-share-directory-menu")) {
			var lastUpdate = this.mhoPrefs.getIntPref("timers.categories");
		
			if (force || ((lastUpdate + (60 * 60 * 24 * 3)) < mhos_timestamp())){
				// It's been more than 3 days, get a new list.
				var req = new XMLHttpRequest();
				req.parent = this;
				req.open("GET", MHO_SHARE.prefs.getCharPref("uris.opml"), true);
			
				req.overrideMimeType("application/xml");
			
				req.onreadystatechange = function (event) {
					if (req.readyState == 4) {
						// Save it locally
						req.parent.saveCategoryListToDisk(req.responseXML);
						req.parent.getNewsList();
					}
				};
			
				req.send(null);
			}
			else {
				// Get the list locally.
				this.getNewsList();
			}
		}
	},
	
	getNewsList : function (force) {
		var lastUpdate = this.mhoPrefs.getIntPref("timers.news");
		
		if (force || ((lastUpdate + (60 * 60 * 1)) < mhos_timestamp())){
			// It's been more than an hour, get a new list.
			var req = new XMLHttpRequest();
			req.parent = this;
			req.open("GET", MHO_SHARE.prefs.getCharPref("uris.newsOpml"), true);
			
			req.overrideMimeType("application/xml");
			
			req.onreadystatechange = function (event) {
				if (req.readyState == 4) {
					// Save it locally
					req.parent.saveNewsListToDisk(req.responseXML);
				}
			};
			
			req.send(null);
		}
		else {
			// Get the list locally.
		}
	},
	
	populateDirectory : function (useCache) {
		var parent = document.getElementById("mho-share-directory-popup");
		
		if (parent.childNodes.length > 1) return;
		
		var fix = Components.classes['@mozilla.org/docshell/urifixup;1'].getService(Components.interfaces.nsIURIFixup);
		var reader = new XMLHttpRequest();
	
		if (!useCache) {
			if (this.opmldoc) {
				// It's already been timed to happen.
				return;
			}
			
			var url = fix.createFixupURI(this.profilePath + "mho-categories.opml", fix.FIXUP_FLAG_ALLOW_KEYWORD_LOOKUP);

	 		reader.open("GET", url.spec, false);
	 		reader.overrideMimeType("application/xml");

			try {
	 			reader.send(null);
			} catch (e) {
				// File does not exist.
				this.getCategoryList(true);
				alert("Mahalo Share is currently downloading the latest category set.\n\nPlease try again in a minute or two.");
				return;
			}
		
			this.opmldoc = reader.responseXML;
			
			setTimeout('MHO_SHARE_TOOLBAR.populateRandomMenu(true);', 5000);
		}
		
		var node = this.opmldoc.getElementsByTagName("body")[0];
		
		if (!node) {
			logMhoShareMsg("No body node found in OPML.");
			return;
		}
		
		while (parent.lastChild) parent.removeChild(parent.lastChild);
		
		for (var i = 0; i < node.childNodes.length; i++){
			if (node.childNodes[i].nodeName == 'outline') {
				this.OPMLOutlineToMenu(node.childNodes[i], parent);
			}
		}
		
		if (useCache) this.opmldoc = null;
		
 		url = fix.createFixupURI(this.profilePath + "mho-news.opml", fix.FIXUP_FLAG_ALLOW_KEYWORD_LOOKUP);

 		reader.open("GET", url.spec, false);
 		reader.overrideMimeType("application/xml");

		try {
 			reader.send(null);
		} catch (e) {
			this.getNewsList(true);
			return;
		}
		
		parent = document.getElementById("mho-share-news-menu");
		
 		var opmldoc = reader.responseXML;
		node = opmldoc.getElementsByTagName("body")[0];
		
		for (var i = 0; i < node.childNodes.length; i++){
			if (node.childNodes[i].nodeName == 'outline') {
				this.OPMLOutlineToMenu(node.childNodes[i], parent);
			}
		}
	},
	
	populateRandomMenu : function (useCache) {
		var parent = document.getElementById("mho-share-random-menu");
		
		if (parent.childNodes.length > 1) return;
		
		if (!useCache) {
			if (this.opmldoc) {
				// It's already been timed to happen.
				return;
			}

			var fix = Components.classes['@mozilla.org/docshell/urifixup;1'].getService(Components.interfaces.nsIURIFixup);
	 		var url = fix.createFixupURI(this.profilePath + "mho-categories.opml", fix.FIXUP_FLAG_ALLOW_KEYWORD_LOOKUP);

	 		var reader = new XMLHttpRequest();
	 		reader.open("GET", url.spec, false);
	 		reader.overrideMimeType("application/xml");

			try {
	 			reader.send(null);
			} catch (e) {
				// File does not exist.
				alert("Mahalo Share is currently downloading the latest category set.\n\nPlease try again in a minute or two.");
				return;
			}
		
			this.opmldoc = reader.responseXML;
			
			setTimeout('MHO_SHARE_TOOLBAR.populateDirectory(true);', 3000);
		}
		
		var node = this.opmldoc.getElementsByTagName("body")[0];
		
		if (!node) {
			logMhoShareMsg("No body node found in OPML.");
			return;
		}
		
		while (parent.lastChild) parent.removeChild(parent.lastChild);
		
		for (var i = 0; i < node.childNodes.length; i++){
			if (node.childNodes[i].nodeName == 'outline') {
				var theNode = node.childNodes[i];
			
				var nodeEl = document.createElement("menuitem");
				nodeEl.url = this.prefs.getCharPref("uris.randomFromCategory") + theNode.getAttribute("text");
				nodeEl.setAttribute("label", theNode.getAttribute("text"));
					
				parent.appendChild(nodeEl);
			}
		}
		
		if (useCache) this.opmldoc = null;
	},
	
	OPMLOutlineToMenu : function (node, parent) {
		// Create a node for the node we're adding.
		var children = [];
		
		for (var i = 0; i < node.childNodes.length; i++){
			if (node.childNodes[i].nodeName == 'outline') {
				children.push(node.childNodes[i]);
			}
		}
		
		if ((children.length > 0) || (node.getAttribute("text") == 'News')){
			var nodeEl = document.createElement("menu");
			nodeEl.setAttribute("ondblclick","this.parentNode.hidePopup(); this.firstChild.hidePopup(); if (event.target == this) { content.document.location.href = '" + node.getAttribute("url")+"'; }");
			nodeEl.setAttribute("label", node.getAttribute("text"));
			
			var nodePopup = document.createElement("menupopup");
			
			if (node.getAttribute("text") == 'News') {
				nodePopup.id = 'mho-share-news-menu';
			}
			
			nodeEl.appendChild(nodePopup);
			parent.appendChild(nodeEl);
			
			for (var i = 0; i < children.length; i++) {
				this.OPMLOutlineToMenu(children[i], nodePopup);
			}
		}
		else {
			// Add sub-level category here.
			var nodeEl = document.createElement("menuitem");
			nodeEl.setAttribute("onclick","content.document.location.href = '" + node.getAttribute("url")+"';");
			nodeEl.setAttribute("label", node.getAttribute("text"));
					
			parent.appendChild(nodeEl);
		}
	},
	
	saveCategoryListToDisk : function (xml) {
		this.saveToProfile("mho-categories.opml", xml);
		this.mhoPrefs.setIntPref("timers.categories", mhos_timestamp());
	},
	
	saveNewsListToDisk : function (xml) {
		this.saveToProfile("mho-news.opml", xml);
		this.mhoPrefs.setIntPref("timers.news", mhos_timestamp());
	},
	
	// Page ratings
	
	rate : function (score) {
		try {
			var url = content.document.location.href;
		} catch (e) {
			return;
		}
		
		var foundIt = false;
		
		for (var i = 0; i < this.ratings.length; i++){
			if (this.ratings[i].url == url) {
				this.ratings[i].score = score;
				var foundIt = true;
			}
		}
		
		if (!foundIt) {
			this.ratings.push({'url': url, 'score': score});
		}
		
		this.updateRatingButtons(score);
		
		var title = content.document.title;
		
		if (score == 2){
			try {
				var suggestUrl = this.prefs.getCharPref("uris.suggestALink") + "?b64linkTitle=" + btoa(title) + "&b64linkURL=" + btoa(url);
			} catch (e) {
				var suggestUrl = this.prefs.getCharPref("uris.suggestALink") + "?b64linkTitle=" + btoa(title.replace(/[^\x00-\x7f]/g, "")) + "&b64linkURL=" + btoa(url);
			}
			
			this.shareOpener = window;
			
			var suggestWindow = open("about:blank", "mho-suggest", "chrome,width=630,height=600,centerscreen=yes,scrollbars=yes");
			
			suggestWindow.contentWindow = content.window;
			suggestWindow.location.href = suggestUrl;
			
			function onSuggestWindowClose() { 
				// Ensure that the suggestion finished.
				var message = this.document.getElementById("recommendMessage");

				if (message) {
					if (message.innerHTML.match("successbox")) {
						var uri = this.document.getElementById("linkURL").value;
						var title = this.document.getElementById("linkTitle").value;
						var serp = this.document.getElementById("searchTerm").value;
						var tags = this.document.getElementById("tags").value;
						var description = this.document.getElementById("comment").value;
						var services = MHO_SHARE_BOOKMARKING.services;
				
						for (var i = 0; i < services.length; i++) {
							if (MHO_SHARE_TOOLBAR.bmPrefs.getBoolPref("bookmarkServices." + services[i])
								&& this.document.getElementById("checkbox-" + services[i]).checked){
								this.opener.MHO_SHARE_TOOLBAR.delaySend(services[i], uri, title, description, tags, serp);
							}
						}
						
						// Add this link to the user's link list.
						var menu = this.opener.document.getElementById("mho-my-links");
						
						if (menu) {
							var menuitem = this.opener.document.createElement("menuitem");
							menuitem.setAttribute("label", title);
							menuitem.uri = url;
							if (description) menuitem.setAttribute("tooltiptext", description);
							else menuitem.setAttribute("tooltiptext", url);
						
							menu.insertBefore(menuitem, menu.firstChild);
						}
					}
				}
			}

			function onSuggestWindowLoad() {
				// Inject the checkboxes
				this.addEventListener("mahalo-recommend-complete", MHO_SHARE_TOOLBAR.onMyEvent, false, true);
				
				var doc = this.document;
				
				var services = MHO_SHARE_BOOKMARKING.services;
				
				var table = doc.getElementById("suggestLinkForm");
				
				if (table) {
					table = table.getElementsByTagName("table")[0];
					var lastRow = table.getElementsByTagName("tr");
					lastRow = lastRow[lastRow.length - 1];
					
					var newRow = doc.createElement("tr");
					var newCell = doc.createElement("td");
					newCell.setAttribute("colspan","2");
					newCell.setAttribute("class","label");
					newCell.appendChild(doc.createTextNode("Share this link ("));
					
					var selectAll = doc.createElement("a");
					selectAll.appendChild(doc.createTextNode("all"));
					selectAll.href = "#";
					
					var onclickFunction = "";
					
					for (var i = 0; i < services.length; i++){
						if (MHO_SHARE_TOOLBAR.bmPrefs.getBoolPref("bookmarkServices." + services[i])){
							onclickFunction += " document.getElementById('checkbox-" + services[i] + "').checked = true; ";
						}
					}
					
					selectAll.setAttribute("onclick", onclickFunction);
					newCell.appendChild(selectAll);
					
					newCell.appendChild(doc.createTextNode(" / "));
					
					var selectNone = doc.createElement("a");
					selectNone.appendChild(doc.createTextNode("none"));
					selectNone.href = "#";
					
					var onclickFunction = "";
					
					for (var i = 0; i < services.length; i++){
						if (MHO_SHARE_TOOLBAR.bmPrefs.getBoolPref("bookmarkServices." + services[i])){
							onclickFunction += " document.getElementById('checkbox-" + services[i] + "').checked = false; ";
						}
					}
					
					selectNone.setAttribute("onclick", onclickFunction);
					newCell.appendChild(selectNone);		
					
					newCell.appendChild(doc.createTextNode(")"));
					newRow.appendChild(newCell);
					
					lastRow.parentNode.insertBefore(newRow, lastRow);
					
					var newRow = doc.createElement("tr");
					var cbCell = doc.createElement("td");
					cbCell.style.paddingBottom = '1em';
					cbCell.setAttribute("colspan","2");
					newRow.appendChild(cbCell);
										
					for (var i = 0; i < services.length; i++) {
						if (MHO_SHARE_TOOLBAR.bmPrefs.getBoolPref("bookmarkServices." + services[i])){
							// Create a checkbox for this one.
							var cbSpan = doc.createElement("span");
							cbSpan.setAttribute("style","float: left;");
							cbSpan.style.width = '50%';
							cbSpan.style.display = 'block';
							
							var cb = doc.createElement("input");
							cb.setAttribute("type","checkbox");
							cb.setAttribute("id","checkbox-" + services[i]);
							cb.style.width = 'auto';
							cb.setAttribute("checked", "true");
							
							cbSpan.appendChild(cb);
							cbSpan.appendChild(doc.createTextNode(" " + MHO_SHARE_BOOKMARKING.serviceData[services[i]].name));
							
							cbCell.appendChild(cbSpan);
						}
					}
					
					lastRow.parentNode.insertBefore(newRow, lastRow);
				}
			}
			
			suggestWindow.addEventListener("unload", onSuggestWindowClose, false);
			suggestWindow.addEventListener("load", onSuggestWindowLoad, false);
		}
		
		MHO_SHARE_API.send_rating(url, score);
	},
	
	delaySend : function (service, uri, title, description, tags, serp) {
		window.setTimeout(function (uri, title, description, tags, serp) { MHO_SHARE_API[service].post(uri, title, description, tags, serp); }, 0, uri, title, description, tags, serp);
	},
	
	updateRatingButtons : function (score) {
		if (document.getElementById("mho-share-rate-yes")) {
			// Clear out the button states
			document.getElementById("mho-share-rate-yes").checked = false;
			document.getElementById("mho-share-rate-maybe").checked = false;
			document.getElementById("mho-share-rate-no").checked = false;
		
			// Check for rating in ratings file
			switch (score.toString()) {
				case '2':
					document.getElementById("mho-share-rate-yes").checked = true;
					break;
				case '1':
					document.getElementById("mho-share-rate-maybe").checked = true;
					break;
				case '0':
					document.getElementById("mho-share-rate-no").checked = true;
					break;
			}
		}
	},
	
	saveRatingsList : function () {
		var data = "1.0\n";
		
		for (var i = 0; i < this.ratings.length; i++){
			data += this.ratings[i].score + "\t"+this.ratings[i].url+"\n";
		}
		
		var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
		file.initWithPath(this.profilePath + "mho-share-ratings");

		var outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance( Components.interfaces.nsIFileOutputStream );

		outputStream.init(file, 0x02 | 0x08 | 0x20, 0600, null);
		
		this.writeBytes(outputStream, data);
			
		outputStream.close();
	},
	
	getRatingsList : function () {
		while (this.ratings.length > 0) this.ratings.pop();
		
		var file, inputStream, lineStream, stillInFile, parts;
		var data = '';
		var line = { value: "" };
		
		file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
		
		file.initWithPath(this.profilePath + "mho-ratings");
		
		if (!file.exists()) {
			// File doesn't exist yet
			return;
		}

		inputStream = Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
		inputStream.init(file, 0x01, 0600, null);
		
		lineStream = inputStream.QueryInterface(Components.interfaces.nsILineInputStream);
		
		do {
			stillInFile = lineStream.readLine(line);
			
			if (line.value == "") {
				continue;
			}
			else {
				var parts = line.value.split("\t");
				
				if (parts.length == 2){
					this.ratings.push({ 'score': parts[0], 'url': parts[1]});
				}
			}
		} while (stillInFile);
		
		lineStream.close();
		inputStream.close();
	},
	
	// Search
	
	doSearch : function () {
		var q = this.search_field.value.replace(/^\s+|\s+$/g, "");
		
		var qUrl = this.prefs.getCharPref("uris.searchService");
		qUrl += encodeURIComponent(q);
		content.document.location.href = qUrl;
		
		MHO_SHARE_API.send_search();
	},
	
	populateMyLinks : function () {
		var menuId = "mho-share-my-links";
		
		var lastUpdate = this.mhoPrefs.getIntPref("timers.links");
		var menu = document.getElementById(menuId);
		
		if (menu.getAttribute("empty") == "true" || ((lastUpdate + (60 * 60 * 1)) < mhos_timestamp())) {
			this.populateMenuFromFeed(menuId, this.prefs.getCharPref("uris.myLinks").replace("%s", this.mhoPrefs.getCharPref("username").toLowerCase())+"&rand=" + (Math.round(Math.random() * 89999) + 10000));
			this.mhoPrefs.setIntPref("timers.links", mhos_timestamp());
		}
	},
	
	populateMyFriendsLinks : function () {
		var menuId = "mho-share-my-friends-links";
		
		var lastUpdate = this.mhoPrefs.getIntPref("timers.friendsLinks");
		var menu = document.getElementById(menuId);
		
		if (menu.getAttribute("empty") == "true" || ((lastUpdate + (60 * 60 * 1)) < mhos_timestamp())) {
			this.populateMenuFromFeed(menuId, this.prefs.getCharPref("uris.myFriendsLinks").replace("%s", this.mhoPrefs.getCharPref("username").toLowerCase()) + "&rand=" + (Math.round(Math.random() * 89999) + 10000));
			this.mhoPrefs.setIntPref("timers.friendsLinks", mhos_timestamp());
		}
	},
	
	populateMenuFromFeed : function (menuId, feedUrl) {
		var req = new XMLHttpRequest();
		req.open("GET", feedUrl, true);
		
		req.onreadystatechange = function () {
			if (req.readyState == 4) {
				var feed = req.responseXML;
				var menu = document.getElementById(menuId);
				
				while (menu.lastChild) menu.removeChild(menu.lastChild);
				
				var items = feed.getElementsByTagName("item");
				
				for (var i = 0; i < items.length; i++){
					var link = items[i].getElementsByTagName("link")[0].firstChild.nodeValue;
					try { var desc = items[i].getElementsByTagName("description")[0].firstChild.nodeValue; } catch (e) { }
					var title = items[i].getElementsByTagName("title")[0].firstChild.nodeValue;
					
					var menuitem = document.createElement("menuitem");
					menuitem.setAttribute("label", title);
					
					if (desc) {
						menuitem.setAttribute("tooltiptext", desc);
					}
					else {
						menuitem.setAttribute("tooltiptext", link);
					}
					
					menuitem.uri = link;
					
					menu.appendChild(menuitem);
				}
				
				menu.setAttribute("empty","false");
			}
		};
		
		req.send(null);
	},
	
	checkForUsername : function () {
		if (this.mhoPrefs.getCharPref("username") == '') {
			return this.promptForUsername();
		}
		else {
			return true;
		}
	},
	
	promptForUsername : function () {
		var username = null;
		
		if (username = prompt("To take advantage of this feature, you must supply your Mahalo username.\n\nWhat is your Mahalo username?")) {
			this.mhoPrefs.setCharPref("username", username.toLowerCase());
			return true;
		}
		
		return false;
	}
};

addEventListener("load", function (event) { MHO_SHARE_TOOLBAR.load(event); }, false);
addEventListener("unload", function (event) { MHO_SHARE_TOOLBAR.unload(event); }, false);

var appcontent = document.getElementById("appcontent");

if (appcontent) {
	appcontent.addEventListener("DOMContentLoaded", function (event) { MHO_SHARE_TOOLBAR.contentChange(event); }, false);
	appcontent.addEventListener("select", function (event) { MHO_SHARE_TOOLBAR.contentChange(event); }, false);
}
